module Eve
  module Api

    class ApiKeyInfo < Eve::Api::Resource

      attr_reader :access_mask, :type, :expires, :characters

      def self.endpoint
        "account/APIKeyInfo.xml.aspx"
      end

      def self.client
        @@xml_client
      end

      def initialize(opts={})
        @access_mask = opts["key"]["accessMask"]
        @type = opts["key"]["type"]
        @expires = opts["key"]["expires"]
        @characters = Characters.new("rowset" => opts["key"]["rowset"])
      end

    end

  end
end

