module Eve
  module Api

    class Characters < Eve::Api::Resource

      Character = Struct.new(:name, :character_id, :corporation_name, :corporation_id, :alliance_id, :alliance_name, :faction_id, :faction_name)

      attr_reader :characters

      def self.endpoint
        "account/Characters.xml.aspx"
      end

      def self.client
        @@xml_client
      end

      def initialize(opts={})
        @characters = opts["rowset"]["row"].map do |r|
                        Character.new(r["name"],
                                      r["characterID"],
                                      r["corporationName"],
                                      r["corporationID"],
                                      r["allianceID"],
                                      r["allianceName"],
                                      r["factionID"],
                                      r["factionName"])
                      end
      end

    end

  end
end

