module Eve
  module Api
    module Client
      class Crest
        attr_reader :parsed_crest_response, :crest_response

        def initialize
          @crest_root_url = "http://public-crest.eveonline.com"
          @crest_response = HTTParty.get(@crest_root_url)
          @parsed_crest_response= JSON.parse(@crest_response.body)

        end

        def motd
          motd_hash = @parsed_crest_response["motd"]
          OpenStruct.new(
            dust: HTTParty.get(motd_hash["dust"]["href"]),
            eve: HTTParty.get(motd_hash["eve"]["href"]),
            server: HTTParty.get(motd_hash["server"]["href"])
          )
        end

        def server_name
          parsed_crest_response["serverName"]
        end

        # Unsupported
        def corporation_roles
          JSON.parse(HTTParty.get(parsed_crest_response["corporationRoles"]["href"]))
        end

        # Unsupported
        def channels
          JSON.parse(HTTParty.get(parsed_crest_response["channels"]["href"]))
        end

        # Unsupported
        def corporations
          JSON.parse(HTTParty.get(parsed_crest_response["corporations"]["href"]))
        end

        def alliances
          JSON.parse(HTTParty.get(parsed_crest_response["alliances"]["href"]))
        end

        def auth_endpoint
          HTTParty.get(parsed_crest_response["authEndpoint"]["href"])
        end
        # Unsupported
        def battle_theatres
          JSON.parse(HTTParty.get(parsed_crest_response["battleTheatres"]["href"]))
        end

        def market_prices
          JSON.parse(HTTParty.get(parsed_crest_response["marketPrices"]["href"]))
        end

        # Unsupported
        def item_types
          JSON.parse(HTTParty.get(parsed_crest_response["itemTypes"]["href"]))
        end

        def types(id)
          url = "#{@crest_root_url}/types/#{id}/"
          puts url
          JSON.parse(HTTParty.get(url))
        end

        # Unsupported
        def decode
          JSON.parse(HTTParty.get(parsed_crest_response["decode"]["href"]))
        end

        # Unsupported
        def bloodlines
          JSON.parse(HTTParty.get(parsed_crest_response["bloodlines"]["href"]))
        end

        def tournaments
          JSON.parse(HTTParty.get(parsed_crest_response["tournaments"]["href"]))
        end

        # Unsupported
        def map
          JSON.parse(HTTParty.get(parsed_crest_response["map"]["href"]))
        end

        #Need Auth
        def virtual_good_store
          JSON.parse(HTTParty.get(parsed_crest_response["virtualGoodStore"]["href"]))
        end

        def wars
          JSON.parse(HTTParty.get(parsed_crest_response["wars"]["href"]))
        end

        def incursions
          JSON.parse(HTTParty.get(parsed_crest_response["incursions"]["href"]))
        end

        # Unsupported
        def races
          JSON.parse(HTTParty.get(parsed_crest_response["races"]["href"]))
        end

        def time
          JSON.parse(HTTParty.get(parsed_crest_response["time"]["href"]))
        end

        def market_types
          JSON.parse(HTTParty.get(parsed_crest_response["marketTypes"]["href"]))
        end

        def server_name
          parsed_crest_response["serverName"]
        end

      end
    end
  end
end
